%%% gewoonweg halverng (+return) intikken, check of de functie f wel goed staat in de file f.m

clear
diary reshalv
disp('Resultaten ook op file=>reshalv')
format long
format compact

disp('BEREKENING VAN  f(x)=0 MBV HALVERING')
disp(' precisie wordt bepaald door absolute verschil van twee opeenvolgende iteranden!')
disp('Indien gewenst kan een grafiek van de functie worden verkregen mbv GRAffUN!')

tol=input('Geef gewenste precisie:');
maxit=input('Geef maximaal aantal iteratieslagen voor iteratieproces:');

x1=input('Geef EERSTE startwaarde voor Halvering:');
x2=input('Geef TWEEDE startwaarde voor Halvering:');

f1=f(x1);
f2=f(x2);
if f1*f2>0
  disp('de functie heeft in de startwaarden gelijk teken. Dus deze zijn niet geschikt!');
  disp('Indien gewenst kan een grafiek van de functie worden verkregen mbv GRAffUN!');
  disp('We stoppen. Herhaal eventueel het proces met andere startwaarden!');
%  stop
  break;
end

dx=abs(x2-x1);
x=x1-dx*0.1:dx/50:x2+dx/20;
plot(x,f(x),x,zeros(size(x)),x1,0,'x',x2,0,'x')
xlabel 'X-WAARDEN';
ylabel 'F(X)-WAARDEN';
grid on
hold on
plot([x1 x1],[f1 0],':',[x2 x2],[f2,0],':')
title('halveringsmethode');
grid on
axis(axis)
figure(gcf)
disp('druk op enter! en verschuif evt.figure(1)-window...');
pause
hold on
itwaarde(1)=x1;
itwaarde(2)=x2;
telit=2;
prec(1)=abs(x1-x2);
prec(2)=prec(1);
precisie=prec(1);

%start van iteratieproces
while telit<maxit & abs(precisie)>tol
   x3=(x2+x1)/2;
   f3=f(x3);
   telit=telit+1;
  if f3==0
      x1=x3;
      precisie=0;
      itwaarde(telit)=x1;
  elseif f(x1)*f(x3)<0
      x2=x3;
      f0=f(x1);
      x0=x1;
      precisie=abs(x1-x2);
      itwaarde(telit)=x2;
  else
      x1=x3;
      f0=f(x2);
      x0=x2;
      precisie=abs(x1-x2);
      itwaarde(telit)=x1;
  end
 if telit==maxit
   disp('maximaal aantal iteratieslagen bereikt')
 end
  prec(telit)=precisie;
  dx=abs(x1-x2);
  f1=f(x1);
  f2=f(x2);
    plot(x3,0,'o')
    hold on
    plot([x1 x1],[f1 0],':',[x2 x2],[f2,0],':')
    title('halvering');
    grid on
    disp('GRAFIEK')
    disp('                          =>voor vervolg druk 2X op toets')
    figure(gcf)
    hold on
    pause
    axis(axis)
    title('halvering')
    figure(gcf)
    hold on
    pause
end

disp('iteratiewaarden')
for i = 1:telit
  disp(itwaarde(i))
end
disp('"precisie"(x[n]-x[n-1])')

for i = 1:telit
  disp(prec(i))
end
aap=input('                         =>voor vervolg druk op toets');
hold off

%figure(1)
figure
plot(itwaarde,'--rs','MarkerSize',20, 'MarkerFaceColor','g');grid;legend('iteratie-waarden')
title('halvering')
xlabel 'AANTAL ITERATIES';
ylabel 'DE ITERATIE-WAARDEN';
grid on
disp('                          =>voor vervolg druk op toets')
pause

%figure(2)
hold off
figure
plot(prec,'--rs','MarkerSize',20, 'MarkerFaceColor','g');legend('precisie-voortgang');grid
title('halvering')
xlabel 'AANTAL ITERATIES';
ylabel 'DE "FOUT"';
grid on
diary off
