%%% gewoonweg koordnwt (+return) intikken, check of de functie f wel goed staat in de file f.m

clear
funnr=0;
disp('Resultaten ook op file=>reskrdnw')
diary reskrdnw
format long
format compact

disp('BEREKENING VAN  f(x)=0 MBV KOORDEN NEWTON')
disp('  Precisie wordt bepaald door absolute verschil van twee opeenvolgende iteranden')
disp('Indien gewenst kan een grafiek van de functie worden verkregen mbv GRAffUN!')

% invoer parameters:
tol=input('Geef gewenste precisie:');
maxit=input('Geef maximaal aantal iteratieslagen voor iteratieproces:');

% initialisatie:
x1=input('Geef EERSTE startwaarde voor Koorden Newton:');
x2=input('Geef TWEEDE startwaarde voor Koorden Newton:');
dx=abs(x2-x1);
 if x1==x2
  disp('x1=x2; ONJUISTE WAARDEN. Begin opnieuw!')
  stop
 end
%  if x1>x2
%   x3=x1;
%   x1=x2;
%   x2=x3;
%  end
f1=f(x1);
f2=f(x2);

% x=x1-dx*0.5:dx/50:x2+dx/10;
  x=x1-2.0:0.001:x2+2.0;
 plot(x,f(x),'b-')
  hold on
 plot(x,zeros(size(x)))
  hold on
 plot(x1,0,'mx','MarkerSize',20)
  hold on
 plot(x2,0,'mx','MarkerSize',20)
  hold on
 plot([x1 x2],[f1 f2],'r--','MarkerSize',10)
  hold on
 plot([x1 x1],[f1 0],':',[x2 x2],[f2,0],':')
  title('koorden newton');
  xlabel 'X-WAARDEN';
  ylabel 'F(X)-WAARDEN';
  grid on
% axis(axis)
 figure(gcf)
 disp('                          =>voor vervolg druk op toets')
 pause
 hold on

itwaarde(1)=x1;
itwaarde(2)=x2;

telit=2;
prec(1)=abs(x1-x2);
prec(2)=prec(1);
precisie=prec(1);
f3=abs(f2-f1);

% start van iteratieproces
while telit<maxit & abs(precisie)>tol & f3~=0
   x3=(x1*f(x2)-x2*f(x1))/(f(x2)-f(x1));
   x1=x2;
   x2=x3;
   f1=f(x1);
   f2=f(x2);
  plot(x3,0,'ko','MarkerSize',10)
   hold on
  plot([x1 x2],[f1 f2],'r--','MarkerSize',10)
   hold on
  plot([x1 x1],[f1 0],':',[x2 x2],[f2,0],':')
   title('koorden newton');
   disp('GRAFIEK')
   xlabel 'X-WAARDEN';
   ylabel 'F(X)-WAARDEN';
   grid on
  figure(gcf)
   hold on
    disp('                          =>voor vervolg druk enkele malen op toets')
 pause
    telit=telit+1;
    itwaarde(telit)=x2;
    precisie=abs(x1-x2)
   if telit==maxit
     disp('maximaal aantal iteratieslagen bereikt')
   end
  prec(telit)=precisie;
end

stop=input('                         =>voor vervolg druk enkele malen op toets');
hold off

figure
plot(itwaarde,'--rs','MarkerSize',20, 'MarkerFaceColor','g');grid;legend('iteratie-waarden')
title('koorden newton');
xlabel 'AANTAL ITERATIES';
ylabel 'ITERATIE-WAARDEN';
grid on
disp('                          =>voor vervolg druk op toets')
pause
hold off

figure
plot(prec,'--rs','MarkerSize',20, 'MarkerFaceColor','g');legend('precisie-voortgang');grid
title('koorden newton');
xlabel 'AANTAL ITERATIES';
ylabel 'DE "FOUT"';
grid on
disp('iteratiewaarden:')
 for i=1:telit
  disp(itwaarde(i))
 end
disp('                          =>voor vervolg druk op toets')
pause
disp('"precisie":ABS(x[n]-x[n-1]):')
 for i=1:telit
  disp(prec(i))
 end
disp('                          =>voor vervolg druk op toets')
pause

diary off
