%%% gewoonweg newton (+return) intikken, check of de functies f en f' wel goed staan in de files f.m, resp. facc.m

clear
funnr=0;
faccnr=0;
disp('Resultaten ook op file=>resnewt1')
diary resnewt1
format long
format compact

% tekst op scherm:
disp('BEREKENING VAN  f(x)=0 MBV NEWTON')
disp('Indien gewenst kan een grafiek van de functie worden verkregen mbv GRAffUN!')
disp('functie te gegeven in f.m')            
disp('Afgeleide te geven in facc.m')
disp(' precisie wordt bepaald door absolute verschil van twee opeenvolgende iteranden!')

% invoerparameters:
tol=input('Geef gewenste precisie:');
maxit=input('Geef maximaal aantal iteratieslagen voor iteratieproces:');
startx=input('Geef startwaarde voor Newtonproces:');

% initialisatie van proces:
x1=startx - f(startx)/facc(startx);
telit=2;
x0=startx;
f0=f(x0);
precisie=abs(x1-x0);
prec(1)=precisie;
itwaarde(1)=x0;
itwaarde(2)=x1;
%proloog?
%dx=-f(x0)/facc(x0);
%fnew=f(x0+dx);
%plot(x0,f0),[x0 x0+dx],[f0 0],'--',x,zeros(size(x)),[x0 x0+dx],[0 0],'o', [x0+dx x0+dx],[0    fnew],':');

   dx=-f(x0)/facc(x0);
   x = x0-0.5*dx:dx/50:x0+2*dx;
   fnew=f(x1);
   plot(x,f(x),[x0 x0+dx],[f0 0],'--',x,zeros(size(x)),[x0 x0+dx],[0 0],'o', [x0+dx x0+dx],[0    fnew],':')
 grid on
   hold on
   disp('                          =>voor vervolg druk op toets')
   pause

% start van iteratieproces
while ((telit<maxit) & (abs(precisie)>tol))

   x0=x1;
   dx=-f(x0)/facc(x0);
   x1=x0 +dx;
   fnew=f(x1);
   f0=f(x0);
   x = x0-0.5*dx:dx/20:x0+2*dx;

   plot(x,f(x),[x0 x0+dx],[f0 0],'--',x,zeros(size(x)),[x0 x0+dx],[0 0],'o', [x0+dx x0+dx],[0    fnew],':')

     title('NEWTON')
     xlabel 'X-WAARDEN';
     ylabel 'F(X)-WAARDEN';
     grid on
%     axis(axis)
     figure(gcf)
     hold on
     disp('                          =>voor vervolg druk op toets')
     pause
   precisie=abs(x1-x0);
   telit=telit+1;
  if telit==maxit
     disp('maximaal aantal iteratieslagen bereikt')
  end
   itwaarde(telit)=x1;
   prec(telit)=precisie;
end

stop=input('                         =>voor vervolg druk op toets');
hold off

disp('iteratiewaarden')
for i = 1:telit
  disp(itwaarde(i))
end

disp('"precisie"(x[n]-x[n-1])')
for i = 1:telit
  disp(prec(i))
end
aap=input('                         =>voor vervolg druk op toets');
hold off

%figure(1)
figure
plot(itwaarde,'--rs','MarkerSize',20, 'MarkerFaceColor','g');grid;legend('iteratie-waarden')
title('Newton');
xlabel 'AANTAL ITERATIES';
ylabel 'DE ITERATIE-WAARDEN';
grid on
disp('                          =>voor vervolg druk op toets')
pause

%figure(2)
hold off
figure
plot(prec,'--rs','MarkerSize',20, 'MarkerFaceColor','g');legend('precisie-voortgang');grid;title('Newton')
xlabel 'AANTAL ITERATIES';
ylabel 'DE "FOUT"';
grid on

diary off
